'use strict';

var vue = require('vue');
var index = require('../_util/props-util/index.js');

const messageProps = {
  prefixCls: String,
  default: [Object, Function],
  duration: {
    default: 3e3
  },
  key: [String, Number]
};
var Message = vue.defineComponent({
  props: messageProps,
  emits: ["close"],
  setup(props, {
    emit
  }) {
    let timer;
    function clearTimer() {
      clearTimeout(timer);
    }
    function retimer() {
      clearTimeout(timer);
      const {
        duration
      } = props;
      if (duration) {
        timer = setTimeout(close, duration);
      }
    }
    function close() {
      emit("close");
    }
    vue.onMounted(() => {
      retimer();
    });
    vue.onBeforeUnmount(() => {
      clearTimer();
    });
    return () => vue.cloneVNode(index.render(props.default), {
      onMouseenter: clearTimer,
      onMouseleave: retimer
    });
  }
});

module.exports = Message;
