'use strict';

var vue = require('vue');
require('../../_util/hooks/index.js');
var index = require('../../_util/props-util/index.js');
var useFalseUntilTruthy = require('../../_util/hooks/useFalseUntilTruthy.js');

const asd = vue.defineComponent({
  name: "display-directive",
  props: {
    visible: Boolean,
    type: {
      type: String,
      default: "if"
    }
  },
  setup(props, {
    slots
  }) {
    const untilTruthy = useFalseUntilTruthy(vue.toRef(props, "visible"));
    return () => {
      var _a;
      const visible = props.visible;
      switch (props.type) {
        case "if":
          return visible ? (_a = slots.default) == null ? void 0 : _a.call(slots) : void 0;
        case "show":
          return vue.withDirectives(index.getSlot(slots)[0], [[vue.vShow, visible]]);
        case "lazy:show":
          return untilTruthy.value ? vue.withDirectives(index.getSlot(slots)[0], [[vue.vShow, visible]]) : void 0;
      }
    };
  }
});

module.exports = asd;
