'use strict';

function addEventListenerWrap(target, eventType, cb, option) {
  if (target.addEventListener) {
    let opt = option;
    if (opt === void 0 && (eventType === "touchstart" || eventType === "touchmove" || eventType === "wheel")) {
      opt = { passive: false };
    }
    target.addEventListener(eventType, cb, opt);
  }
  return {
    remove: () => {
      if (target.removeEventListener) {
        target.removeEventListener(eventType, cb);
      }
    }
  };
}

module.exports = addEventListenerWrap;
