'use strict';

var vue = require('vue');
var shared = require('@vue/shared');
var core = require('@vueuse/core');
var useNameSpace = require('../_util/hooks/useNameSpace2.js');
var context = require('./context.js');

const preCls = "x-anchor-link";
var _sfc_main = vue.defineComponent({
  name: preCls,
  props: {
    href: String,
    title: String
  },
  setup(props) {
    const ns = useNameSpace(preCls);
    const linkRef = vue.ref();
    const anchorContext = vue.inject(context.AnchorContextKey);
    const anchorLiinkContext = vue.inject(context.AnchorLiinkContextKey, void 0);
    const indent = (anchorLiinkContext == null ? void 0 : anchorLiinkContext.indent) ? (anchorLiinkContext == null ? void 0 : anchorLiinkContext.indent) + 1 : 1;
    const isActive = core.computedEager(() => anchorContext.value.value == props.href);
    const state = vue.reactive({
      el: linkRef,
      href: vue.toRef(props, "href"),
      indent
    });
    vue.provide(context.AnchorLiinkContextKey, state);
    anchorContext.links.push(state);
    vue.onBeforeUnmount(() => {
      shared.remove(anchorContext.links, state);
    });
    function onClick() {
      anchorContext.setActive(props.href);
    }
    return {
      ns,
      linkRef,
      indent,
      style: `padding-left: ${indent * 16}px`,
      isActive,
      onClick
    };
  }
});

module.exports = _sfc_main;
