'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var core = require('@vueuse/core');

function scroller(el, d, onStart, onEnd) {
  let raf;
  vue.onBeforeUnmount(() => raf == null ? void 0 : raf.pause());
  const ret = {
    transiting: false,
    scroll
  };
  function scroll(option) {
    ret.transiting = true;
    const t = Date.now();
    const _el = vue.unref(el);
    const sy = _el.scrollTop, offset = option.y - sy;
    ret.transiting = true;
    _el.style.scrollBehavior = "unset";
    onStart == null ? void 0 : onStart();
    raf == null ? void 0 : raf.pause();
    raf = core.useRafFn(() => {
      const r = Math.min((Date.now() - t) / d, 1);
      _el.scrollTop = sy + offset * r;
      if (r >= 1) {
        _el.style.scrollBehavior = "";
        raf.pause();
        ret.transiting = false;
        onEnd == null ? void 0 : onEnd();
      }
    });
  }
  return ret;
}

exports.scroller = scroller;
