'use strict';

var vue = require('vue');
var hljs = require('highlight.js/lib/core');
var xml = require('highlight.js/lib/languages/xml');
var javascript = require('highlight.js/lib/languages/javascript');
require('highlight.js/styles/atom-one-dark.css');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var hljs__default = /*#__PURE__*/_interopDefaultLegacy(hljs);
var xml__default = /*#__PURE__*/_interopDefaultLegacy(xml);
var javascript__default = /*#__PURE__*/_interopDefaultLegacy(javascript);

hljs__default["default"].registerLanguage("javascript", javascript__default["default"]);
hljs__default["default"].registerLanguage("html", xml__default["default"]);
const prefixCls = "x-code";
const Code = vue.defineComponent({
  name: prefixCls,
  props: {
    code: String,
    language: String,
    trim: {
      default: true
    }
  },
  setup(props, {
    slots
  }) {
    const codeRef = vue.ref();
    const resultRef = vue.computed(() => {
      let code = props.code;
      if (!code)
        return {};
      if (props.trim)
        code = code.trim();
      if (props.language) {
        return hljs__default["default"].highlight(code, {
          language: props.language,
          ignoreIllegals: true
        });
      } else {
        return hljs__default["default"].highlightAuto(code);
      }
    });
    const languageRef = vue.computed(() => resultRef.value.language || props.language);
    function setCode() {
      if (slots.default)
        return;
      if (!codeRef.value)
        return;
      codeRef.value.innerHTML = resultRef.value.value;
    }
    vue.onMounted(setCode);
    vue.watch([vue.toRef(props, "code"), vue.toRef(props, "language")], setCode);
    return () => {
      var _a;
      const cls = [prefixCls];
      const language = languageRef.value;
      return vue.createVNode("code", {
        "class": ["hljs " + language, cls]
      }, [slots.default ? (_a = slots.default) == null ? void 0 : _a.call(slots) : vue.createVNode("pre", {
        "ref": codeRef
      }, null)]);
    };
  }
});
Code.install = (app) => {
  app.component(Code.name, Code);
};

module.exports = Code;
