'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var moment = require('moment');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var moment__default = /*#__PURE__*/_interopDefaultLegacy(moment);

function formatDate(date, format) {
  if (!date)
    return "";
  const formatFunc = (date2) => date2 == null ? void 0 : date2.format(format);
  if (Array.isArray(date)) {
    return date.map((e) => formatFunc(e));
  } else {
    return formatFunc(date);
  }
}
function toMoment(date, format, strict) {
  if (!date)
    return null;
  const formatFunc = (date2) => moment__default["default"](date2, format, strict);
  if (Array.isArray(date)) {
    return date.map((e) => formatFunc(e));
  } else {
    return formatFunc(date);
  }
}

exports.formatDate = formatDate;
exports.toMoment = toMoment;
