'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
require('../_util/css/index.js');
var IconFont = require('./IconFont.js');
var formatLength = require('../_util/css/format-length.js');

const MyIconFont = IconFont({
  scriptUrl: "//at.alicdn.com/t/c/font_2698224_awmh8fka824.js"
});
const iconProps = {
  type: String,
  spin: Boolean,
  color: String,
  size: [String, Number]
};
const Icon = vue.defineComponent({
  name: "x-icon",
  props: iconProps,
  emits: ["click"],
  setup(props, {
    emit
  }) {
    function onClick(e) {
      emit("click", e);
    }
    return () => {
      const {
        spin
      } = props, prefixCls = "x-icon";
      const cls = [prefixCls, {
        [`${prefixCls}-spin`]: spin
      }];
      const style = {
        fontSize: formatLength(props.size),
        color: props.color
      };
      return vue.createVNode(MyIconFont, {
        "class": cls,
        "style": style,
        "type": props.type,
        "onClick": onClick
      }, null);
    };
  }
});
Icon.install = (app) => {
  app.component(Icon.name, Icon);
};

exports["default"] = Icon;
exports.iconProps = iconProps;
