'use strict';

var vue = require('vue');
var index$1 = require('../_util/props-util/index.js');
var inputProps = require('./inputProps.js');
var index = require('../button/index.js');
var input = require('./input.js');

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const prefixCls = "x-input-search";
var InputSearch = vue.defineComponent({
  name: prefixCls,
  components: {
    Button: index,
    Input: input
  },
  props: __spreadProps(__spreadValues({}, inputProps), {
    enterButton: String || Boolean
  }),
  setup(props, {
    attrs,
    emit,
    expose,
    slots
  }) {
    const showBtn = vue.computed(() => !!props.enterButton || props.enterButton === "" || !!slots.enterButton);
    const btnText = vue.computed(() => {
      let text = "\u{1F50D}";
      if (typeof props.enterButton === "string") {
        text = props.enterButton || text;
      }
      return text;
    });
    const btnIcon = vue.computed(() => {
      if (props.enterButton === "")
        return "search";
      if (props.enterButton === true)
        return "search";
    });
    const inputRef = vue.ref();
    function onSearch() {
      emit("search", inputRef.value.value);
      inputRef.value.focus();
    }
    expose({
      focus() {
        inputRef.value.focus();
      },
      blur() {
        inputRef.value.blur();
      },
      get value() {
        return inputRef.value.value;
      }
    });
    return (vm) => {
      const cls = [prefixCls, {
        [`${prefixCls}-enter`]: showBtn.value
      }];
      let enterNode = showBtn.value && (index$1.getComponent(vm, "enterButton") || vue.createVNode(index, {
        "type": "primary"
      }, {
        default: () => [btnText.value]
      }));
      if (!enterNode)
        enterNode = vue.createTextVNode("\u{1F50D}");
      const _enterNode = function() {
        return enterNode;
      }();
      enterNode = vue.createVNode("div", {
        "class": `${prefixCls}_enter`,
        "onClick": onSearch
      }, [enterNode]);
      return vue.createVNode(input, vue.mergeProps({
        "class": cls,
        "ref": inputRef
      }, __spreadValues(__spreadValues({}, props), attrs), {
        "onPressEnter": onSearch
      }), {
        addonAfter: () => showBtn.value && enterNode,
        suffix: () => !showBtn.value && enterNode
      });
    };
  }
});

module.exports = InputSearch;
