'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var utils = require('./utils.js');
var Submenu = require('./Submenu.js');

const submenuProps = {
  node: Object,
  label: [String, Object],
  value: [String, Number],
  children: Array,
  icon: [Object, Function],
  disabled: Boolean
};
var MenuItemGroup = vue.defineComponent({
  name: "x-menu-item-group",
  props: submenuProps,
  setup(props) {
    const {
      paddingLeftRef,
      parentPaddingLeftRef
    } = utils.useMenu(props);
    vue.provide(Submenu.SubmenuContextKey, {
      props,
      paddingLeftRef: parentPaddingLeftRef
    });
    return () => {
      const prefixCls = "x-menu-item-group";
      const childrenNode = vue.createVNode("div", {
        "class": `${prefixCls}_children`
      }, [props.children.map(utils.createItem)]);
      return vue.createVNode("div", {
        "class": prefixCls
      }, [vue.createVNode("div", {
        "class": `${prefixCls}_label`,
        "style": `padding-left:${paddingLeftRef.value}px`
      }, [props.label]), childrenNode]);
    };
  }
});

exports["default"] = MenuItemGroup;
exports.submenuProps = submenuProps;
