'use strict';

var vue = require('vue');
var shared = require('@vue/shared');
var index$1 = require('../_util/props-util/index.js');
var index = require('../MessageManager/index.js');
require('../icon/index.js');
require('./style/index.js');
var Icon = require('../icon/Icon.js');

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const iconMap = {
  success: vue.h(Icon["default"], {
    type: "check-circle"
  }),
  warning: vue.h(Icon["default"], {
    type: "warn-circle"
  }),
  error: vue.h(Icon["default"], {
    type: "close-circle"
  }),
  info: vue.h(Icon["default"], {
    type: "info-circle"
  }),
  loading: vue.h(Icon["default"], {
    type: "loading",
    spin: true
  })
};
const prefixCls = "x-message";
const instance = index.newInstace({
  prefixCls
});
let __key = 0;
function getKey() {
  return "__" + __key++;
}
const Message = (content, options) => {
  var _a;
  options = typeof content == "string" ? __spreadProps(__spreadValues({}, options), {
    content
  }) : content;
  const key = (_a = options.key) != null ? _a : getKey();
  const obj = instance.add(__spreadProps(__spreadValues({}, options), {
    key,
    default: () => {
      var _a2;
      return vue.createVNode("div", {
        "class": [prefixCls, `${prefixCls}-${options.type}`]
      }, [vue.cloneVNode(options.icon || iconMap[(_a2 = options.type) != null ? _a2 : "info"], {
        class: `${prefixCls}_icon`
      }), index$1.render(options.content), options.closable && vue.createVNode(Icon["default"], {
        "type": "cross",
        "class": `${prefixCls}_close`,
        "onClick": onClick
      }, null)]);
    }
  }));
  function onClick(e) {
    e.preventDefault();
    e.stopPropagation();
    obj.close();
  }
  return obj.close;
};
Message.destroyAll = () => instance.removeAll();
const messageTypes = Object.keys(iconMap);
messageTypes.forEach((type) => {
  Message[type] = (arg1, options) => {
    const content = shared.isObject(arg1) ? arg1.content : arg1;
    return Message(__spreadProps(__spreadValues({
      content
    }, options), {
      type
    }));
  };
});
Message.install = (app) => {
  app.config.globalProperties.$message = Message;
};

module.exports = Message;
