'use strict';

var vue = require('vue');
var index$1 = require('../_util/props-util/index.js');
var index = require('../MessageManager/index.js');
require('../icon/index.js');
require('./style/index.js');
var Icon = require('../icon/Icon.js');

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const prefixCls = "x-notification";
const instance = index.newInstace({
  prefixCls
});
let __key = 0;
function getKey() {
  return "__" + __key++;
}
const Notification = {
  create: (options) => {
    var _a;
    const key = (_a = options.key) != null ? _a : getKey();
    const obj = instance.add(__spreadProps(__spreadValues({}, options), {
      key,
      duration: options.duration === void 0 ? 5e3 : options.duration,
      default: () => {
        return vue.createVNode("div", {
          "class": prefixCls
        }, [vue.withDirectives(vue.createVNode("div", {
          "class": `${prefixCls}_cover`
        }, [index$1.render(options.cover)]), [[vue.vShow, options.cover]]), vue.createVNode("div", {
          "class": `${prefixCls}_header`
        }, [vue.createVNode("div", {
          "class": `${prefixCls}_title`
        }, [index$1.render(options.title)]), vue.withDirectives(vue.createVNode("div", {
          "class": `${prefixCls}_close`,
          "onClick": onClose
        }, [vue.createVNode(Icon["default"], {
          "type": "cross"
        }, null)]), [[vue.vShow, options.closable]]), vue.withDirectives(vue.createVNode("div", {
          "class": `${prefixCls}_description`
        }, [index$1.render(options.description)]), [[vue.vShow, options.description]]), vue.withDirectives(vue.createVNode("div", {
          "class": `${prefixCls}_meta`
        }, [index$1.render(options.meta)]), [[vue.vShow, options.meta]])])]);
      },
      transitionProps: {
        width: 0,
        height: 0
      }
    }));
    function onClose(e) {
      e.preventDefault();
      e.stopPropagation();
      obj.close();
    }
    return obj.close;
  },
  destroyAll: instance.removeAll,
  // Plugin
  install(app) {
    app.config.globalProperties.$notification = Notification;
  }
};

module.exports = Notification;
