'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function getClosestPoint(val, { marks = [], step, min, max }) {
  var _a;
  const points = Object.keys(marks).map(parseFloat);
  if (step != null) {
    const decimals = ((_a = `${step}`.split(".")[1]) == null ? void 0 : _a.length) || 0;
    points.push(+(Math.round((val - min) / step) * step + min).toFixed(decimals));
  }
  const diffs = points.map((p) => Math.abs(val - p));
  return points[diffs.indexOf(Math.min(...diffs))];
}
function ensureValueInRange(val, { min, max }) {
  return Math.min(max, Math.max(min, val));
}
function ensureValuePrecision(val, props) {
  return getClosestPoint(val, props);
}
function generateTrack({ step, marks, min, max }) {
  let arr = Array(max - min);
  for (let i = min; i <= max; i += step) {
    arr[i - min] = i;
  }
  if (arr[arr.length - 1] != max) {
    arr[arr.length - 1] = max;
  }
  Object.keys(marks || {}).forEach((p) => {
    arr[+p - min] = +p;
  });
  return arr.filter((p) => p != null);
}

exports.ensureValueInRange = ensureValueInRange;
exports.ensureValuePrecision = ensureValuePrecision;
exports.generateTrack = generateTrack;
exports.getClosestPoint = getClosestPoint;
