import { defineComponent, toRef, withDirectives, vShow } from 'vue';
import '../../_util/hooks/index.js';
import { getSlot } from '../../_util/props-util/index.js';
import useFalseUntilTruthy from '../../_util/hooks/useFalseUntilTruthy.js';

const asd = defineComponent({
  name: "display-directive",
  props: {
    visible: Boolean,
    type: {
      type: String,
      default: "if"
    }
  },
  setup(props, {
    slots
  }) {
    const untilTruthy = useFalseUntilTruthy(toRef(props, "visible"));
    return () => {
      var _a;
      const visible = props.visible;
      switch (props.type) {
        case "if":
          return visible ? (_a = slots.default) == null ? void 0 : _a.call(slots) : void 0;
        case "show":
          return withDirectives(getSlot(slots)[0], [[vShow, visible]]);
        case "lazy:show":
          return untilTruthy.value ? withDirectives(getSlot(slots)[0], [[vShow, visible]]) : void 0;
      }
    };
  }
});

export { asd as default };
