import { watch, computed } from 'vue';

function useMergedState(controlledStateRef, uncontrolledStateRef, setter) {
  watch(controlledStateRef, (value) => {
    if (value !== void 0) {
      uncontrolledStateRef.value = value;
    }
  });
  return computed({
    get() {
      return controlledStateRef.value === void 0 ? uncontrolledStateRef.value : controlledStateRef.value;
    },
    set(v) {
      const oldVal = uncontrolledStateRef.value;
      uncontrolledStateRef.value = v;
      if (oldVal != v)
        setter == null ? void 0 : setter(v);
    }
  });
}

export { useMergedState as default };
