import { onMounted, getCurrentInstance, onBeforeUnmount } from 'vue';
import resizeobserver from '../Dom/resizeobserver.js';
import { findDOMNode } from '../props-util/index.js';

function useResizeObserver(handler) {
  onMounted(() => {
    const el = findDOMNode(getCurrentInstance());
    resizeobserver.observer(el, handler);
  });
  onBeforeUnmount(() => {
    const el = findDOMNode(getCurrentInstance());
    resizeobserver.dispose(el);
  });
}

export { useResizeObserver as default };
