import moment from 'moment';

function formatDate(date, format) {
  if (!date)
    return "";
  const formatFunc = (date2) => date2 == null ? void 0 : date2.format(format);
  if (Array.isArray(date)) {
    return date.map((e) => formatFunc(e));
  } else {
    return formatFunc(date);
  }
}
function toMoment(date, format, strict) {
  if (!date)
    return null;
  const formatFunc = (date2) => moment(date2, format, strict);
  if (Array.isArray(date)) {
    return date.map((e) => formatFunc(e));
  } else {
    return formatFunc(date);
  }
}

export { formatDate, toMoment };
