import { defineComponent, ref, createVNode, withDirectives, vShow } from 'vue';
import ExpandTransition from './expand-transition.js';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
const ExpandTransition2 = defineComponent({
  name: "x-expand-transition2",
  props: {
    visible: Boolean,
    placement: String
  },
  setup(props, {
    slots
  }) {
    const div = ref();
    const transitionProps = {
      widthProp: "width",
      heightProp: "height",
      style: "display: flex; justify-content: flex-end; align-items: flex-end;",
      onEnter(el) {
        div.value.setAttribute("style", `width: ${div.value.scrollWidth}px; height: ${div.value.scrollHeight}px;`);
      },
      onAfterEnter(el) {
        div.value.setAttribute("style", "");
      },
      onBeforeLeave(el) {
        div.value.setAttribute("style", `width: ${div.value.scrollWidth}px; height: ${div.value.offsetHeight}px;`);
      },
      onAfterLeave(el) {
        div.value.setAttribute("style", "");
      }
    };
    return () => createVNode(ExpandTransition, transitionProps, {
      default: () => [withDirectives(createVNode("div", {
        "style": "overflow: unset"
      }, [createVNode("div", {
        "ref": div
      }, __spreadValues({}, slots))]), [[vShow, props.visible]])]
    });
  }
});

export { ExpandTransition2 as default };
