import * as components from './components.js';
export { default as DragResize } from './drag-resize/index.js';
export { default as Icon } from './icon/Icon.js';
export { default as Button } from './button/index.js';
export { default as Tooltip } from './tooltip/Tooltip.js';
export { default as Popover } from './popover/Popover.js';
export { default as VirtualList } from './virtual-list/index.js';
export { default as Select } from './select/Select.js';
export { default as Tag } from './tag/index.js';
export { default as Switch } from './switch/index.js';
export { default as Slider } from './slider/index.js';
export { default as Rate } from './rate/index.js';
export { default as DatePicker } from './date-picker/index.js';
export { default as Dropdown } from './dropdown/index.js';
export { default as Card } from './card/index.js';
export { default as Message } from './message/index.js';
export { default as Notification } from './notification/index.js';
export { default as Modal } from './modal/Modal.js';
export { default as Table } from './table/index.js';
export { default as Code } from './code/index.js';
export { default as Blockquote } from './blockquote/index.js';
export { default as Space } from './space/index.js';
export { default as Drawer } from './drawer/index.js';
export { default as Progress } from './progress/index.js';
export { default as Image } from './image/Image.js';
export { default as Window } from './window/Window.js';
export { default as Menu } from './menu/Menu.js';
export { default as ExpandTransition } from './expand-transition/expand-transition.js';
export { default as BorderLight } from './border-light/index.js';
export { default as Sunken } from './sunken/index.js';
export { default as Acrylic } from './acrylic/index.js';
export { default as Input } from './input/input.js';
export { default as InputSearch } from './input/search.js';
export { default as Radio } from './radio/Radio.js';
export { default as RadioGroup } from './radio/Group.js';
export { default as Checkbox } from './checkbox/Checkbox.js';
export { default as CheckboxGroup } from './checkbox/Group.js';
export { DateCalendar as Calendar, DateCalendar, MonthCalendar, YearCalendar } from './calendar/Calendar.js';
export { default as RangeCalendar } from './calendar/RangeCalendar.js';
export { default as Form } from './form/Form.js';
export { default as FormItem } from './form/FormItem.js';
export { default as A } from './typography/a.vue.js';
export { default as SimpleTable } from './typography/simple-table.vue.js';
export { default as TabPane } from './tabs/TabPane.js';
export { default as Tabs } from './tabs/Tabs.js';
export { default as Anchor } from './anchor/Anchor.vue.js';
export { default as AnchorLink } from './anchor/AnchorLink.vue.js';
export { default as Skeleton } from './skeleton/skeleton.js';
export { default as SkeletonItem } from './skeleton/skeleton-item.js';

const install = (app) => {
  Object.keys(components).forEach((key) => {
    const component = components[key];
    if (component.install) {
      app.use(component);
    }
  });
  return app;
};
var index = {
  install
};

export { index as default };
