import { ExtractPropTypes, PropType } from 'vue';
import { RowData, TableColumn } from './interface';
declare const tableProps: {
    prefixCls: {
        default: string;
    };
    columns: PropType<TableColumn<RowData>[]>;
    data: PropType<RowData[]>;
    rowProps: PropType<(rowData: RowData, rowIndex: number) => object>;
    maxHeight: NumberConstructor;
    rowClass: PropType<string | ((rowData: RowData, rowIndex: number) => string)>;
    bordered: BooleanConstructor;
    bottomBordered: {
        default: boolean;
    };
    scrollX: NumberConstructor;
    virtualScroll: BooleanConstructor;
    size: {
        type: PropType<"small" | "medium" | "large">;
        default: string;
    };
};
export type TableProps = ExtractPropTypes<typeof tableProps>;
declare const Table: import("vue").DefineComponent<{
    prefixCls: {
        default: string;
    };
    columns: PropType<TableColumn<RowData>[]>;
    data: PropType<RowData[]>;
    rowProps: PropType<(rowData: RowData, rowIndex: number) => object>;
    maxHeight: NumberConstructor;
    rowClass: PropType<string | ((rowData: RowData, rowIndex: number) => string)>;
    bordered: BooleanConstructor;
    bottomBordered: {
        default: boolean;
    };
    scrollX: NumberConstructor;
    virtualScroll: BooleanConstructor;
    size: {
        type: PropType<"small" | "medium" | "large">;
        default: string;
    };
}, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    prefixCls: {
        default: string;
    };
    columns: PropType<TableColumn<RowData>[]>;
    data: PropType<RowData[]>;
    rowProps: PropType<(rowData: RowData, rowIndex: number) => object>;
    maxHeight: NumberConstructor;
    rowClass: PropType<string | ((rowData: RowData, rowIndex: number) => string)>;
    bordered: BooleanConstructor;
    bottomBordered: {
        default: boolean;
    };
    scrollX: NumberConstructor;
    virtualScroll: BooleanConstructor;
    size: {
        type: PropType<"small" | "medium" | "large">;
        default: string;
    };
}>>, {
    size: "small" | "medium" | "large";
    prefixCls: string;
    bordered: boolean;
    virtualScroll: boolean;
    bottomBordered: boolean;
}>;
export default Table;
