import type { PropType, VNodeChild } from 'vue';
import type { AlignType } from '../align/interface';
import { ActionType } from '../trigger/Trigger';
declare const _default: {
    prefixCls: {
        default: string;
    };
    trigger: {
        type: PropType<ActionType>;
        default: string;
    };
    disabled: BooleanConstructor;
    title: PropType<VNodeChild | JSX.Element>;
    visible: BooleanConstructor;
    popupClass: (ObjectConstructor | StringConstructor)[];
    popupStyle: (ObjectConstructor | StringConstructor)[];
    transitionName: {
        default: string;
    };
    getPopupContainer: PropType<(triggerNode: HTMLElement) => HTMLElement>;
    align: PropType<AlignType>;
    placement: {
        type: PropType<"left" | "right" | "top" | "bottom" | "topLeft" | "leftTop" | "topRight" | "rightTop" | "bottomRight" | "rightBottom" | "bottomLeft" | "leftBottom">;
        default: string;
    };
    builtinPlacements: PropType<{
        left: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        right: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        top: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        bottom: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        topLeft: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        leftTop: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        topRight: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        rightTop: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        bottomRight: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        rightBottom: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        bottomLeft: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
        leftBottom: {
            points: string[];
            overflow: {
                adjustX: number;
                adjustY: number;
            };
            offset: number[];
            targetOffset: number[];
        };
    }>;
    mouseEnterDelay: {
        default: number;
    };
    mouseLeaveDelay: {
        default: number;
    };
};
export default _default;
